# -*- coding: utf-8; mode: rpm-spec -*-
# $Id: emacs22.spec,v 1.57 2006/06/14 06:45:20 eugene Exp $

%define cvsdate 20060614
%define emacs_version 22.0.50
%define cvsversion 22.0.50.1
%define gnus_version 5.11
%define shortname emacs
%define tramp_version 2.0.53
%define speedbar_version 1.0
%define erc_version 5.1.2
%define alternatives_version 0.1.0-alt2

# subpackages to build;
%def_enable nox
%def_enable athena
%def_enable gtk

# temporary disable build motif binary for x86_64
%ifarch x86_64
%def_disable motif
%else
%def_enable motif
%endif

Name: emacs22
Version: %emacs_version
Release: alt0.13.%cvsdate.M24.1

Group: Editors
Summary: GNU Emacs text editor
License: GPL

URL: http://www.gnu.org/software/emacs/


Source0: %shortname-%cvsdate.tar.bz2

# Included into upstream
# Source1: rsync://ftp.gnu.org/gnu/%shortname/leim-%version.tar.bz2

# Included into upstream
# Source2: TUTORIAL.ru
# Included into upstream
# Source3: smtpmail.el

Source7: README.KOI8-U

#Source110: http://prdownloads.sourceforge.net/php-mode/php-mode.el
#Source111: emacs-mode-php.site-start.el

# Source12: gnu-mini.xpm
# Source13: gnu-normal.xpm
# Source14: gnu-large.xpm

# from Serhij Hlodin
Source16: CHANGES.ukr
Source17: INSTALL.ukr
Source18: README.UK

Source24: %name-nox.alternatives
Source25: %name-athena.alternatives
Source26: %name-motif.alternatives
Source27: %name-gtk.alternatives

# Mdk's and ALT's global configs merged: the X resources
Source31: %shortname-22.0.50-alt0.1-xresources-ALT

# List of some large .elc files to be compressed:
#Source40: %shortname-21.2-el-to-compress.ls

Source41: emacs21-rus-win-keyboard-alt2.el

Source50: README.ALT-ru_RU.KOI8-R
Source51: check-shadows

Source60: %name.desktop

################### Patches  ##########################
# ALT's libtinfo; POSIX locks via fcntl convention:
Patch0: %shortname-22.0.50-alt-system.patch

# Try to load also bzipped2 .el/.elc files 
# as well as with gzipped and uncompressed variants (supported before)
# Patch1: %shortname-21.2-alt14-load-el_bz2.patch
# Instead of load-el_bz2 patch short patch to modify default value
# of jka-compr-load-suffixes:
Patch1: %shortname-22.0.50-alt0.10-jka-compr_bz2_load.patch

# isn't applied (21.2-alt1): indicator is already disabled in the GNU release:
# Patch2: %shortname-21.1-enc-kb-short-indicator.patch

Patch3: %shortname-22.0.50-alt0.7-clipboard.patch

# We don't want the whole pkg depend on rcs 
# just because someone may want to use it:
Patch4: %shortname-22.0.50-hide-rcs-deps.patch

Patch5: %shortname-22.0.50-Meta-Alt-Ctrl-Hyper-super-discard-state.patch

# already freshest
# Patch6: %shortname-21.2-HEAD-pc-select.diff
Patch7: %shortname-22.0.50-pc-select-private-mark.patch
# Merged into upstream
# Patch8: %shortname-21.2-ediff-diff-options-check-c.patch
# Disabled
# Patch10: %shortname-22.0.50-face-font-selection-slant-important.patch
# Fixes from CVS - not needed for CVS sources
# Patch11: %shortname-21.3-use-handler-for-load-of-absolute.patch
# Patch12: %shortname-21.3-use-handler-for-load-of-suffixed.patch

# FIXME
# Patch13: %shortname-21.3-vc-cvs-registered-autoload-parts.patch

Patch14: %shortname-22.0.50-rh-no_rpath.patch
# Merged into upstream
# Patch15: %shortname-21.2-x86_64.patch

# New fix for finding aspell dictionaries. This is only replace
# elements in ispell-dictionary-alist for dictionaries that found
# .dat file
# Patch16: %shortname-22.0.50-ispell-nofind_dict.patch
# Merged in upstream
# Patch16: %shortname-22.0.50-ispell-find_noclean.patch

# These two patches make the real work for ukrainisation:
Patch20: %shortname-22.0.50-alt0.9-uk.patch
Patch21: leim-22.0.50-uk.patch
Patch22: leim-22.0.50-belarusian.patch
# added belarussian and proprer russianw dictionary support
Patch23: %shortname-22.0.50-ispell-belarusian.patch
Patch24: %shortname-22.0.50-ispell-russianw.patch

Patch33: %shortname-22.0.50-alt0.4-more-cyrillic-support.patch
#Patch33: %shortname-21.2-alt10-cyrillic-cp-lang-envs.patch

# FIXME: Merged into upstream?
# Patch34: %shortname-21.1-lang-env-prereqs.patch

Patch35: %shortname-22.0.50-tutorial-ru.patch

# Bug with scroll-margin patch - fixed in upstream
# Patch40: %shortname-22.0.50-margin_scroll.patch

# Decode invalid encoded headers
Patch41: %shortname-22.0.50-gnus-invalid_decode.patch

# rms fix for flyspell-buffer - merged into upstream
# Patch45: %shortname-22.0.50-flyspell-tex_fix.patch
# fix for work with aspell in locale encoding other than dictionary encoding
Patch46: %shortname-22.0.50-ispell-aspell_noencode.patch

# Check save-place-alist elements after loading from ~/.emacs-places
Patch47: %shortname-22.0.50-saveplace_check_cell.patch

# Fix info installation
Patch50: %shortname-22.0.50-info_install.patch

# Increase PURESIZE
Patch55: %shortname-22.0.50-incr_puresize.patch

# Fix hooks.texi syntax - fixed in upstream
# Patch60: %shortname-22.0.50-hooks_texi-syntax.patch

# End of Patches #
##################

# We use awk for output parsing and error-msg detection:
BuildRequires(build): awk
# We use zme:
BuildRequires(install): bzip2-utils
# <term.h> is there since then:
BuildRequires(build): libtinfo >= 5.2.20020622-alt2
# Emacs now requires Texinfo version 4.2.
BuildRequires(build): texinfo >= 4.2

# %_configure_target must set --host= for a correct emacs build;
# added since then:
BuildRequires(build): rpm >= 4.0.4-alt12

# We need sendmail to properly dump emacs during bootstrap
BuildRequires(build): sendmail-common

# We need emacs-base
BuildPreReq: %shortname-base >= 0.0.4-alt2

BuildPreReq: python-base python-modules-compiler python-modules-encodings rpm-build-python rpm-build-compat

# el-pkgutils in emacs-base (=0.0.4). emacs-devel is for macrodefinions
BuildPreReq: %shortname-devel
# All emacs pkgs should be removed from the list.
# XFree86-devel or XFree86-devel-static?

BuildPreReq: tetex-core tetex-latex

# Strange build deps:
#BuildRequires: inews  postfix

# We need new alternatives system for build:
BuildPreReq: libalternatives-devel >= %alternatives_version

# Automatically added by buildreq on Mon Sep 05 2005
BuildRequires: ImageMagick alternatives aspell cvs ddd fontconfig freetype2 glib2-devel libXaw3d-devel libatk-devel cairo-devel libgtk+2-devel libjpeg-devel libpango-devel libpng-devel libtiff-devel libtinfo-devel libungif-devel openmotif-devel openssl pkgconfig postfix sox wget XFree86-devel XFree86-libs xpm-devel XFree86-locales zlib-devel

%description
Emacs is an extensible, customizable, self-documenting real-time
display editor.  Emacs contains special code editing features, an
extension language (Emacs Lisp), and the capability to read mail, news
and more without leaving the editor.

This package includes things you need to run the Emacs editor, so you
need to install this package if you intend to use Emacs.  You also
need to install the actual Emacs program package (%name-nox or
%name-X11).  Install %name-nox if you are not going to use the X
Window System; install %name-X11 if you will be using X.

#
%package common
Summary: Things needed to run the GNU Emacs text editor
Summary(ru_RU.UTF-8): Необходимое для запуска текстового редактора GNU Emacs
Group: Editors
Provides: %_libexecdir/%shortname
Obsoletes: %name
Obsoletes: %shortname-common
Provides: %shortname-common = %emacs_version-%release
# now emacs22 obsoletes emacs21
Obsoletes: emacs21-common
Provides: emacs21-common = %emacs_version-%release
# Common is useless without an Emacs binary:
Requires: %name = %emacs_version-%release
# speedbar now separate package
Requires: %shortname-speedbar

Requires: %shortname-base >= 0.0.4-alt2

Conflicts: etcskel < 2.0.2-alt1
Conflicts: emacs-prog-modes < 0.1-alt7
# ispell-uk 0.5 is broken, and can cause hang in flyspell mode
Conflicts: ispell-uk < 0.6-alt1
# emacs22 have tramp inside
Obsoletes: %shortname-tramp
Provides: %shortname-tramp = %tramp_version-%release
# emacs22 have ses inside
Obsoletes: %shortname-ses <= 1.0-alt2.031130
Provides: %shortname-ses = %emacs_version-%release
# emacs22 conflicts with old emacs-w3 (with url package inside)
Conflicts: %shortname-w3 <= 4.0-alt0.8.pre.47
Provides: %shortname-url = %emacs_version-%release
# gnuserv seems needed to be build with emacs22
Conflicts: %shortname-gnuserv <= 3.12.7-alt1

# otherwise we have heavy useless dependency on python
AutoReq: yes, nopython

%description common
GNU Emacs is an extensible, customizable, self-documenting real-time
display editor.  Emacs contains special code editing features, an
extension language (Emacs Lisp), and the capability to read mail, news
and more without leaving the editor.

This package includes things you need to run the Emacs editor, so you
need to install this package if you intend to use Emacs.  You also
need to install the actual Emacs program package (%name-nox or
%name-X11).  Install %name-nox if you are not going to use the X
Window System; install %name-X11 if you will be using X.

#
%package el
Summary: The sources for Lisp programs included with GNU Emacs
Summary(ru_RU.UTF-8): Исходный код Lisp программ, поставляемых с GNU Emacs
Group: Development/Other
Requires: %name-common = %emacs_version-%release
Obsoletes: %shortname-el
Provides: %shortname-el = %emacs_version-%release
# now emacs22 obsoletes emacs21
Obsoletes: emacs21-el
Provides: emacs21-el = %emacs_version-%release

%description el
Emacs-el contains the Emacs Lisp sources for many of the programs
included with the main GNU Emacs text editor package.

You need to install %name-el only if you intend to modify any of the
Emacs packages or see some Lisp examples.

If you need the sources for %name-leim, install %name-leim-el.

#
%package leim
Summary: GNU Emacs Lisp code for input methods for internationalization
Summary(ru_RU.UTF-8): Код GNU Emacs Lisp для методов ввода
Group: Editors
Requires: %name-common = %emacs_version-%release
Obsoletes: %shortname-leim
Provides: %shortname-leim = %emacs_version-%release
# now emacs22 obsoletes emacs21
Obsoletes: emacs21-leim
Provides: emacs21-leim = %emacs_version-%release

%description leim
The Lisp code for input methods for various international scripts for GNU Emacs.

#
%package leim-el
Summary: The Emacs Lisp source code for input methods included in %name-leim
Summary(ru_RU.UTF-8): Исходный код Lisp для методов ввода, поставляемых с %name-leim
Group: Development/Other
Requires: %name-leim = %emacs_version-%release
Obsoletes: %shortname-leim-el
Provides: %shortname-leim-el = %emacs_version-%release
# now emacs22 obsoletes emacs21
Obsoletes: emacs21-leim-el
Provides: emacs21-leim-el = %emacs_version-%release

%description leim-el
Emacs-leim-el contains the Emacs Lisp sources for the Emacs Lisp code
for input methods for various international scripts of GNU Emacs.

You need to install %name-leim-el only if you intend to modify any of theses
GNU Emacs packages, see some Lisp examples or for reference for configuring your
localized input methods.

#
%if_enabled nox
%package nox
Summary: The GNU Emacs text editor without support for the X Window System
Summary(ru_RU.UTF-8): Текстовый редактор GNU Emacs без поддержки X Window System
Group: Editors
PreReq: %name-common = %emacs_version-%release
Provides: %name = %emacs_version-%release
Provides: emacsen
Provides: %shortname = %emacs_version-%release
Obsoletes: %shortname-nox
Provides: %shortname-nox = %emacs_version-%release
# now emacs22 obsoletes emacs21
Obsoletes: emacs21-nox
Provides: emacs21-nox = %emacs_version-%release
# 0.2.0 for new alternatives format
PreReq: alternatives >= %alternatives_version

%description nox
Emacs-nox is the GNU Emacs text editor program without support for
the X Window System.

You need to install this package only if you plan on exclusively using
GNU Emacs without the X Window System (%name-X11-athena, %name-X11-motif, 
%name-X11-gtk will work both in X and out of X, but %name-nox will only work 
outside of X). You will also need to install the %name-common package in
order to run GNU Emacs.
%endif

#
%package X11
Summary: Things needed to run the GNU Emacs text editor in X Window System
Summary(ru_RU.UTF-8): Необходимое для запуска редактора GNU Emacs в X Window System
Group: Editors
PreReq: %name-common = %emacs_version-%release
Requires: emacs-X11-program
Conflicts: app-defaults < 0.2.1-alt1
Obsoletes: %shortname-X11

%description X11
This package includes things you need to run the Emacs editor in X Window
System, so you need to install this package if you intend to use Emacs with X
Window.  You also need to install the actual Emacs program package
(%name-X11-athena, %name-X11-motif or %name-X11-gtk). You will also need to
install the %name-common package in order to run GNU Emacs.

#
%if_enabled athena
%package X11-athena
Summary: The GNU Emacs text editor for the X Window System (athena)
Summary(ru_RU.UTF-8): Текстовый редактор GNU Emacs для X Window System (athena)
Group: Editors
PreReq: %name-common = %emacs_version-%release
PreReq: %name-X11 = %emacs_version-%release
Provides: %name = %emacs_version-%release
Provides: emacsen
Provides: emacs-X11-program
Provides: %shortname = %emacs_version-%release
Provides: %shortname-X11 = %emacs_version-%release
# now emacs22 obsoletes emacs21
Obsoletes: emacs21-X11
Provides: emacs21-X11 = %emacs_version-%release
# 0.2.0 for new alternatives format
PreReq: alternatives >= %alternatives_version

%description X11-athena
Emacs-X11-athena includes the GNU Emacs text editor program for use with the X
Window System using athena widget set (it provides support for the mouse and
other GUI elements).  Emacs-X11-athena will also run GNU Emacs outside of X,
but it has a larger memory footprint than the 'non-X' GNU Emacs package
(%name-nox).

Install %name-X11-athena if you are going to use Emacs with the X Window
System and you like athena look.  You should also install %name-X11-athena if
you are going to run GNU Emacs both with and without X (it will work fine both
ways).  You will also need to install the %name-common and %name-X11 package
in order to run Emacs.
%endif

#
%if_enabled motif
%package X11-motif
Summary: The GNU Emacs text editor for the X Window System (motif)
Summary(ru_RU.UTF-8): Текстовый редактор GNU Emacs для X Window System (motif)
Group: Editors
PreReq: %name-common = %emacs_version-%release
PreReq: %name-X11 = %emacs_version-%release
Provides: %name = %emacs_version-%release
Provides: emacsen
Provides: emacs-X11-program
Provides: %shortname = %emacs_version-%release
Provides: %shortname-X11 = %emacs_version-%release
# 0.2.0 for new alternatives format
PreReq: alternatives >= %alternatives_version

%description X11-motif
Emacs-X11-motif includes the GNU Emacs text editor program for use with the X
Window System using motif toolkit (it provides support for the mouse and
other GUI elements).  Emacs-X11-motif will also run GNU Emacs outside of X, but
it has a larger memory footprint than the 'non-X' GNU Emacs package
(%name-nox).

Install %name-X11-motif if you are going to use Emacs with the X Window
System and you like motif look.  You should also install %name-X11-motif if you
are going to run GNU Emacs both with and without X (it will work fine both
ways).  You will also need to install the %name-common and %name-X11 package in
order to run Emacs.
%endif

#
%if_enabled gtk
%package X11-gtk
Summary: The GNU Emacs text editor for the X Window System (gtk)
Summary(ru_RU.UTF-8): Текстовый редактор GNU Emacs для X Window System (gtk)
Group: Editors
PreReq: %name-common = %emacs_version-%release
PreReq: %name-X11 = %emacs_version-%release
Provides: %name = %emacs_version-%release
Provides: emacsen
Provides: emacs-X11-program
Provides: %shortname = %emacs_version-%release
Provides: %shortname-X11 = %emacs_version-%release
# 0.2.0 for new alternatives format
PreReq: alternatives >= %alternatives_version

%description X11-gtk
Emacs-X11-gtk includes the GNU Emacs text editor program for use with the X
Window System using gtk+ toolkit v.2 (it provides support for the mouse and
other GUI elements).  Emacs-X11-gtk will also run GNU Emacs outside of X, but
it has a larger memory footprint than the 'non-X' GNU Emacs package
(%name-nox).

Install %name-X11-gtk if you are going to use Emacs with the X Window
System and you like gtk+ look.  You should also install %name-X11-gtk if you
are going to run GNU Emacs both with and without X (it will work fine both
ways).  You will also need to install the %name-common and %name-X11 package
in order to run Emacs.
%endif

#
%package elisp-manual
Summary: Emacs Lisp Manual
Summary(ru_RU.UTF-8): Руководство по языку Emacs Lisp
Group: Editors
Requires: %name-common = %emacs_version-%release
# obsoletes old elisp-manual
Obsoletes: %shortname-elisp-manual <= 2.8-alt1
Provides: %shortname-elisp-manual = %emacs_version-%release

%description elisp-manual
This package contain full description of Emacs Lisp language

#
%package gnus
Version: %gnus_version
Summary: Gnus package for Emacs
Summary(ru_RU.UTF-8): Пакет Gnus для Emacs
Group: Editors
Requires: %name-common = %emacs_version-%release
Conflicts: %shortname-ngnus
Provides: gnus
# obsoletes old gnus
Obsoletes: %shortname-gnus <= 5.10.6
Provides: %shortname-gnus = %gnus_version-%release

%description gnus
Gnus is a program for Emacs which enable read news and mail from Emacs.

All Emacs Lisp code is byte-copmpiled, install %name-gnus-el for sources.

#
%package gnus-el
Version: %gnus_version
Summary: The Emacs Lisp sources for bytecode included in %name-gnus
Summary(ru_RU.UTF-8): Исходный код Lisp для байткода из %name-gnus
Group: Development/Other
Requires: %name-common = %emacs_version-%release
Requires: %name-gnus = %gnus_version-%release
# obsoletes old gnus
Obsoletes: %shortname-gnus-el <= 5.10.6
Provides: %shortname-gnus-el = %gnus_version-%release

%description gnus-el
%name-gnus-el contains the Emacs Lisp sources for the bytecode
included in the %name-gnus package, that extends the Emacs editor.

You need to install %name-gnus-el only if you intend to modify any of the
%name-gnus code or see some Lisp examples.

#
%package speedbar
Version: %speedbar_version
Summary: Speedbar package for Emacs
Group: Editors
Requires: %name-common = %emacs_version-%release
Provides: speedbar
Provides: %shortname-speedbar = %speedbar_version-%release
# obsoletes old speedbar
Conflicts: %shortname-cedet <= 1.0-alt0.7.beta3b
Obsoletes: %shortname-cedet-speedbar <= 0.15beta2-alt0.8.beta3b
Provides: %shortname-cedet-speedbar = %speedbar_version-%release

%description speedbar
Speedbar - Everything browser for Emacs.

#
%package erc
Version: %erc_version
Summary: Emacs client for IRC
Summary(ru_RU.UTF-8): IRC Клиент для Emacs
Group: Networking/IRC
Requires: %name-common = %emacs_version-%release
Provides: %shortname-erc = %erc_version-%release
# obsoletes old emacs-erc
Obsoletes: %shortname-erc <= 5.0.4-alt1

%description erc
ERC is an IRC client for Emacs.

#
%package erc-el
Version: %erc_version
Summary: The Emacs Lisp sources for bytecode included in %name-erc
Summary(ru_RU.UTF-8): Исходный код Lisp для байткода из %name-erc
Group: Development/Other
Requires: %name-common = %emacs_version-%release
Requires: %name-erc = %erc_version-%release

%description erc-el
%name-erc-el contains the Emacs Lisp sources for the bytecode
included in the %name-erc package, that extends the Emacs editor.

You need to install %name-erc-el only if you intend to modify any of the
%name-erc code or see some Lisp examples.


%prep
%setup -q -n %shortname

%patch0 -p1
%patch1 -p1
# The indicator turned off in GNU's 21.2 release, the patch no needed so far. 
# %patch2 -p1
%patch3 -p1

%patch4 -p1
%patch5 -p1 -b .ctrl
# %patch6 -p2
%patch7 -p1
# %patch8 -p1
# %patch10 -p1
# %patch11 -p1
# %patch12 -p1
# %patch13 -p1
%patch14 -p1
# %patch15 -p1

# FIXME Fixed?
# %patch16 -p1

# Ukrainian docs:
%__cp %SOURCE16 .
%__cp %SOURCE17 .
%__cp %SOURCE18 .
%__cp %SOURCE7 .

%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1

# add support for prereq-features of language-environment-info
# %patch34 -p1
# add CP*-based lang-envs and font support:
%patch33 -p1

%patch35 -p1

# Fixed in upstream
# %patch40 -p1

%patch41 -p1

# Merged into upstream
# %patch45 -p1
%patch46 -p1

%patch47 -p1

%patch50 -p1
%patch55 -p1
# %patch60 -p1

# support for russianw ispell dictionary is moved to Patch24

# README.ALT
%__cp %SOURCE50 .

perl -pi -e 's|(\.\./info/[[:alpha:]-]+)|$1.info|g' man/*
# rm -rf info/*

%define Substage printf 'Substage #%%s. %%s:\\n'

# We build two binaries (with X and without X support) 
# in several symmetric substages.

%Substage 0 "Clear and create the build directories"
[ -d build-nox ] && %__rm -rf build-nox; %__mkdir_p build-nox
[ -d build-athena ] && %__rm -rf build-athena; %__mkdir_p build-athena
[ -d build-motif ] && %__rm -rf build-motif; %__mkdir_p build-motif
[ -d build-gtk ] && %__rm -rf build-gtk; %__mkdir_p build-gtk

%build
%__autoconf
# Try to detect errors and break on errors:
%define detect_elisp_errs 2>&1 | awk '/!! /{ r++; } END{ if (r) printf "There were %%d errors while recompiling Emacs Lisp modules.\\n", r; exit r; } /.*/'

# We do not want to use anything from an existing Emacs installation:
export EMACSLOADPATH="$(pwd)"/lisp

# we require at least one binary to use at substage 3 and later
%if_enabled gtk
  %define stage3bin gtk
%else
  %if_enabled athena
    %define stage3bin athena
  %else
    %if_enabled motif
      %define stage3bin motif
    %else
      %if_enabled nox
        %define stage3bin nox
      %else
        echo "ERROR: You disabled all %shortname binary subpackages!"
        echo "enable at least one (nox, athena, motif or gtk) binary subpackage."
        exit 11;
      %endif
    %endif
  %endif
%endif

%Substage 1 "Configure"

# we need Makefile for printable formats of elisp-manual
pushd lispintro
chmod 755 ./configure
%configure
popd
pushd lispref
%configure
popd

%define _configure_script ../configure
%if_enabled nox
pushd build-nox
%configure --sharedstatedir=/var --with-gcc --with-pop --with-x=no
popd
%endif
%if_enabled athena
pushd build-athena
%configure --sharedstatedir=/var --with-gcc --with-pop --with-x-toolkit=athena --with-png --with-jpeg --with-xpm --with-gif --with-tiff
popd
%endif
%if_enabled gtk
pushd build-gtk
%configure --sharedstatedir=/var --with-gcc --with-pop --with-x-toolkit=gtk --with-png --with-jpeg --with-xpm --with-gif --with-tiff
popd
%endif
%if_enabled motif
# export CFLAGS="%optflags -I%_prefix/X11R6/include"
# export LDFLAGS="-Wl,-L%_prefix/X11R6/%_lib"
pushd build-motif
%configure --sharedstatedir=/var --with-gcc --with-pop --with-x-toolkit=motif --with-png --with-jpeg --with-xpm --with-gif --with-tiff
popd
%endif

# MH-E autoloads fixed
# %__mkdir_p build-nox/lisp/mh-e
# %__mkdir_p build-athena/lisp/mh-e
# %__mkdir_p build-motif/lisp/mh-e
# %__mkdir_p build-gtk/lisp/mh-e

%Substage 2 "Initial make all" 
#no SMP
%if_enabled nox
pushd build-nox; make bootstrap; popd
%endif
%if_enabled athena
pushd build-athena; make bootstrap; popd
%endif
%if_enabled motif
pushd build-motif; make bootstrap; popd
%endif
%if_enabled gtk
pushd build-gtk; make bootstrap; popd
%endif

%Substage 3 "Make supplementary (and important) things only once (asymmetricly) 
 (for possibly more capabilities -- in the X build)"

pushd build-%stage3bin
make -C man
{
    # Recompile so that the patches we have applied are effective:
    # The goal `updates' should update all the generated code
    # (autoloads, custom-deps etc.). 
    # Also compile php-mode and the small new file for Cyrillic support.
    make -C lisp \
        updates \
        international/cyrillic-codepages-setup.elc \
        recompile
#       progmodes/php-mode.elc \
} %detect_elisp_errs
popd # build-%stage3bin

%Substage 4 "Final make all (now that we have all patched Lisp code compiled, 
 also a bit asymmetric), clean previous binaries"

%define override_from_stage3() if [ ! '%stage3bin'=='%{1}' ]; then rm -rf etc leim; %__ln_s -f ../build-%stage3bin/{etc,leim} . ; fi

# no SMP
%if_enabled athena
pushd build-athena
  # Override some data with more complete from the X build
  # (exactly the X variant of the data will be included in the package,
  # so emacs-athena has to work correctly in this environment):
  %override_from_stage3 athena
  %__rm -f src/emacs src/emacs-*
  make
popd
%endif
%if_enabled motif
pushd build-motif
  # Override some data with more complete from the X build
  # (exactly the X variant of the data will be included in the package,
  # so emacs-motif has to work correctly in this environment):
  %override_from_stage3 motif
  %__rm -f src/emacs src/emacs-*
  make
popd
%endif
%if_enabled nox
pushd build-nox
  # Override some data with more complete from the X build
  # (exactly the X variant of the data will be included in the package,
  # so emacs-nox has to work correctly in this environment):
  %override_from_stage3 nox
  %__rm -f src/emacs src/emacs-*
  make
popd
%endif
%if_enabled gtk
pushd build-gtk
  # Override some data with more complete from the X build
  # (exactly the X variant of the data will be included in the package,
  # so emacs-nox has to work correctly in this environment):
  %override_from_stage3 gtk
  %__rm -f src/emacs src/emacs-*
  make
popd
%endif

# printable formats of elisp-manual
pushd lispintro
      make emacs-lisp-intro.dvi
popd
pushd lispref
      make elisp.dvi
popd


%install
%__mkdir_p %buildroot%prefix
# GZIP_PROG= for disable compress installed .el files - this function better
# realized in el-pkgutils
%makeinstall -C build-%stage3bin GZIP_PROG=
%if_enabled nox
%__install -p -m755 build-nox/src/%shortname %buildroot%_bindir/%name-nox
%endif
%if_enabled athena
%__install -p -m755 build-athena/src/%shortname %buildroot%_bindir/%name-athena
%endif
%if_enabled motif
%__install -p -m755 build-motif/src/%shortname %buildroot%_bindir/%name-motif
%endif
%if_enabled gtk
%__install -p -m755 build-gtk/src/%shortname %buildroot%_bindir/%name-gtk
%endif
# remove the installed duplicate emacs binary
# -- it'll be a link managed by `alternatives':
%__rm -f %buildroot%_bindir/%shortname
%__rm -f %buildroot%_bindir/%shortname-%emacs_version

################
# Menu support #
################
%if_with menu
  %__install -d %buildroot%_menudir
  cat <<'EOF' > %buildroot%_menudir/%name-X11
?package(%name-X11): \
	needs="X11" \
	section="Applications/Editors" \
	icon="%name.png" \
	title="GNU Emacs 22" \
	longtitle="Powerful editor from the GNU project" \
	command="emacs-X11"
EOF
%else
  %__install -d %buildroot%_desktopdir
  %__install -p -m644  %SOURCE60 %buildroot%_desktopdir/%name.desktop
%endif
# backwards compatibility with Master 2x/Compact 30
%{?!_niconsdir:%define _niconsdir %_iconsdir}
# New emacs icons (from Andrew Zhilin)
%__install -p -m644 -D etc/images/icons/emacs_16.png %buildroot%_miconsdir/%name.png
%__install -p -m644 -D etc/images/icons/emacs_32.png %buildroot%_niconsdir/%name.png
%__install -p -m644 -D etc/images/icons/emacs_48.png %buildroot%_liconsdir/%name.png

# All the install's below have nothing to do with the Source directory
# So we want to make the command arguments shorter 
# by replacing "%buildroot" with "."

pushd %buildroot # there will be a popd below

# leim's Makefile doesn't ignore .orig; remove them:
find .%_datadir/%shortname/%emacs_version/leim -type f -name '*.orig' -print0 \
     | xargs -0 rm -f

# Site start configuration:
# Link to a file provided by emacsen-startscripts pkg:
(cd .%_datadir/emacs/%emacs_version/lisp; %__ln_s ../../../../..%_sysconfdir/emacs/site-start.el)
# making start scripts
%__mkdir_p %buildroot%_emacs_sitestart_dir
%__install -p -m0644 %SOURCE41 %buildroot%_emacs_sitestart_dir/rus-win-keyboard.el

#######################
# Various other stuff #
#######################

# %__mkdir_p .%_libdir/%shortname/site-lisp

%__mv .%_mandir/man1/{,g}ctags.1
%__mv .%_bindir/{,g}ctags

# Exclude speedbar:
# %__rm -f .{%_datadir/%shortname/%emacs_version/lisp,%_infodir}/speedbar*

# Exclude antlr-mode:
# %__rm -f .%_datadir/%shortname/%emacs_version/lisp/progmodes/antlr-mode.el*

# Remove Gnus:
# %__rm -f .%_datadir/%shortname/%emacs_version/lisp/gnus/format-spec*
# %__rm -rf .%_datadir/%shortname/%emacs_version/lisp/gnus 
# %__rm -f .%_infodir/{gnus,emacs-mime,message}*
# %__rm -rf .%_datadir/%shortname/%emacs_version/etc/gnus*

%__rm -f .%_infodir/info*
%__rm -f .%_infodir/dir

########################
# Alternatives support #
########################
%__install -d %buildroot%_altdir
%if_enabled nox
%__install -p -m644 %SOURCE24 %buildroot%_altdir/%name-nox
%endif
%if_enabled athena
%__install -p -m644 %SOURCE25 %buildroot%_altdir/%name-athena
%endif
%if_enabled motif
%__install -p -m644 %SOURCE26 %buildroot%_altdir/%name-motif
%endif
%if_enabled gtk
%__install -p -m644 %SOURCE27 %buildroot%_altdir/%name-gtk
%endif

###############
# X resources #
###############
xrdir=%_sysconfdir/X11/app-defaults
%__mkdir_p ."$xrdir"
%__install -p -m0644 %SOURCE31 ."$xrdir/Emacs"
unset xrdir

popd # "%buildroot"

#####################
# Create file lists #
#####################
# INFO
%define common_infos ada-mode,autotype,calc,ccmode,cl,dired-x,ebrowse,ediff,efaq,%shortname,eshell,eudc,flymake,forms,idlwave,mh-e,newsticker,org,pcl-cvs,pgg,rcirc,reftex,sc,ses,smtpmail,tramp,url,vip,viper,widget,woman
%define gnus_infos emacs-mime,gnus,message,sieve
%define gnus_infos_pattern gnus\\|emacs-mime\\|message\\|sieve
%define speedbar_infos_pattern speedbar
%define erc_infos_pattern erc
%define elisp_infos_pattern elisp\\|eintr

# source emacs pgktools (bash functions that call el-functions)
. %_libdir/%shortname/el-pkgutils.sh
EMACS_BIN="%name-%stage3bin"
EMACS_SEARCH_ROOT="%buildroot"
EL_PKGUTILS_ROOT=""
# Clear the lists:
%__rm -f {main,leim}{,-el}.ls info.ls

# Generate them:
# INFO
common_infos=( $(ls "%buildroot"%_infodir/*.info* \
| sed -e "s:^%buildroot%_infodir/::" \
| sed -e 's:\.info.*$::' | sort -u \
| egrep -v %gnus_infos_pattern \
| egrep -v %speedbar_infos_pattern \
| egrep -v %erc_infos_pattern \
| egrep -v %elisp_infos_pattern ) )

( # save IFS
IFS=,
if [[ '%common_infos' != "${common_infos[*]}" ]]; then
      echo "common_infos lists do not match, correct them!"
      exit 1
fi
) || false

# fraction \
#  '(dirs "%_libexecdir/%shortname/%emacs_version" "%%dir") "main.ls"' \
#  '(files "%_libexecdir/%shortname/%emacs_version"
#     (lambda(f) (if (string-match "/movemail$" f) "%%attr(-,root,mail)")) )
#   "main.ls"' \
#  \
#  '(dirs "%_datadir/%shortname/%emacs_version/etc" "%%dir") "main.ls"' \
#  '(files "%_datadir/%shortname/%emacs_version/etc"
#     (lambda(f) (if (string-match "gnus" f) "#")) )
#   "main.ls"'

find "%buildroot%_libexecdir/%shortname/%emacs_version" \
    "%buildroot%_datadir/%shortname/%emacs_version/etc" -type d -print \
    | awk '// {gsub ("%buildroot","",$0); print "%%dir " $0}' > main.ls
find "%buildroot%_libexecdir/%shortname/%emacs_version" -type f -print | awk '/\/movemail$/ { printf "%%attr(-,root,mail) "} // {gsub ("%buildroot","",$0); print $0}' >> main.ls
find "%buildroot%_datadir/%shortname/%emacs_version/etc" -type f -print | awk '/gnus/ { printf "#"} // {gsub ("%buildroot","",$0); print $0}' >> main.ls

standard_fraction_el_elc main "%_datadir/%shortname/%emacs_version/lisp"
standard_fraction_el_elc leim "%_datadir/%shortname/%emacs_version/leim"

# INFO
printf '%%s\n' %_infodir/{%common_infos}'.info*' >> main.ls
# mv %buildroot%_infodir/dir %buildroot%_infodir/elisp.dir

# Prepare the trick for linking etc/ into docs:
%__ln_s $(relative %_emacs_datadir/%emacs_version/etc %_docdir/%name-%emacs_version/etc) etc/

# Substitute emacs22-common with emacs-common for buildreq
%__mkdir_p %buildroot%_sysconfdir/buildreqs/packages/substitute.d
echo %shortname-common > %buildroot%_sysconfdir/buildreqs/packages/substitute.d/%name-common
# Substitute emacs22-leim with emacs-leim for buildreq
echo %shortname-leim > %buildroot%_sysconfdir/buildreqs/packages/substitute.d/%name-leim
# Substitute emacs22-gnus with emacs-gnus for buildreq
echo %shortname-gnus > %buildroot%_sysconfdir/buildreqs/packages/substitute.d/%name-gnus
# Substitute emacs22-X11.* with emacs-X11 for buildreq
echo %shortname-X11 > %buildroot%_sysconfdir/buildreqs/packages/substitute.d/%name-X11
%if_enabled athena
echo %shortname-X11 > %buildroot%_sysconfdir/buildreqs/packages/substitute.d/%name-X11-athena
%endif
%if_enabled motif
echo %shortname-X11 > %buildroot%_sysconfdir/buildreqs/packages/substitute.d/%name-X11-motif
%endif
%if_enabled gtk
echo %shortname-X11 > %buildroot%_sysconfdir/buildreqs/packages/substitute.d/%name-X11-gtk
%endif
%if_enabled nox
# Substitute emacs22-nox with emacs-nox for buildreq
echo %shortname-nox > %buildroot%_sysconfdir/buildreqs/packages/substitute.d/%name-nox
%endif

# check-shadows script
%__install -p -m755 %SOURCE51 %buildroot%_bindir/check-shadows

# fix main.ls backup files list
%__subst '/\.bak$/d' *.ls

# Scripts

# common
%post common
%install_info {%common_infos}.info

%preun common
%uninstall_info {%common_infos}.info

# nox
%if_enabled nox
%post nox
%register_alternatives %name-nox

%preun nox
%unregister_alternatives %name-nox
%endif

%post X11
%update_menus

%postun X11
%clean_menus

# athena
%if_enabled athena
%post X11-athena
%register_alternatives %name-athena

%preun X11-athena
%unregister_alternatives %name-athena
%endif

# motif
%if_enabled motif
%post X11-motif
%register_alternatives %name-motif

%preun X11-motif
%unregister_alternatives %name-motif
%endif

# gtk
%if_enabled gtk
%post X11-gtk
%register_alternatives %name-gtk

%preun X11-gtk
%unregister_alternatives %name-gtk
%endif

# elisp-manual
%post elisp-manual
%install_info elisp.info
%install_info eintr.info

%preun elisp-manual
%uninstall_info elisp.info
%uninstall_info eintr.info

# gnus
%post gnus
%install_info gnus.info
%install_info message.info
%install_info emacs-mime.info
%install_info sieve.info

%preun gnus
%uninstall_info gnus.info
%uninstall_info message.info
%uninstall_info emacs-mime.info
%uninstall_info sieve.info

# speedbar
%post speedbar
%install_info speedbar.info

%preun speedbar
%uninstall_info speedbar.info

# erc
%post erc
%install_info erc.info

%preun erc
%uninstall_info erc.info

#
%files common -f main.ls
%doc AUTHORS BUGS README README.KOI8-U README.UK CHANGES.ukr INSTALL.ukr README.ALT-ru_RU.KOI8-R
# The trick for symlinking etc/:
%doc --no-dereference etc/etc

# %config(noreplace) %_sysconfdir/emacs/site-start.d/php.el

%_bindir/*
#%_bindir/b2m
#%_bindir/check-shadows
#%_bindir/ebrowse
#%_bindir/emacsclient
#%_bindir/etags
#%_bindir/gctags
#%_bindir/grep-changelog
#%_bindir/rcs-checkin
%if_enabled nox
%exclude %_bindir/%name-nox
%endif
%if_enabled athena
%exclude %_bindir/%name-athena
%endif
%if_enabled motif
%exclude %_bindir/%name-motif
%endif
%if_enabled gtk
%exclude %_bindir/%name-gtk
%endif

%_mandir/man?/*

%dir %_libexecdir/%shortname
# %dir %_libdir/%shortname/site-lisp

# For now game scores stored separately in each user's home directory
# %attr(2755, root, games) %_libdir/%shortname/%emacs_version/%_target_platform/update-game-score

#%dir %_emacslispdir
%_emacslispdir/*.el*
%dir %_emacs_datadir/%emacs_version
%dir %_emacs_datadir/%emacs_version/site-lisp
%_emacs_datadir/%emacs_version/site-lisp/*
%dir %_emacs_datadir/%emacs_version/leim

# Some .el-files that have .elc-companions,
# but are still preferrable to have in the main
# package (for reference) may be listed here:
#%_datadir/%name/%emacs_version/lisp/bindings.el -- probably there is no need for this
#%_datadir/%name/%emacs_version/lisp/mail/sc.el
#%_datadir/%name/%emacs_version/lisp/term-nasty.el

# This should be a symlink
%_emacs_datadir/%emacs_version/lisp/site-start.el

%exclude %_emacs_datadir/%emacs_version/etc/images/gnus
%exclude %_emacs_datadir/%emacs_version/etc/images/smilies

# speedbar into separate package
%exclude %_emacs_datadir/%emacs_version/lisp/dframe.elc
%exclude %_emacs_datadir/%emacs_version/lisp/sb-image.elc
%exclude %_emacs_datadir/%emacs_version/lisp/speedbar.elc
# erc into separate package
%exclude %_emacs_datadir/%emacs_version/lisp/erc/

%_emacs_sitestart_dir/*

# Game scores
# %dir %attr(775, games, games) %_localstatedir/games/%shortname
# %config(noreplace) %attr(664, games, games) %_localstatedir/games/%shortname/*

# Substitute for buidreq
%_sysconfdir/buildreqs/packages/substitute.d/%name-common

# %exclude %_infodir/dir
%exclude %_localstatedir/games/%shortname

#
%files el -f main-el.ls

#
%files leim -f leim.ls
# Substitute for buidreq
%_sysconfdir/buildreqs/packages/substitute.d/%name-leim

#
%files leim-el -f leim-el.ls

#
%if_enabled nox
%files nox
%_bindir/%name-nox
%_altdir/%name-nox
# Substitute for buidreq
%_sysconfdir/buildreqs/packages/substitute.d/%name-nox
%endif

#
%files X11
%config(noreplace) %_sysconfdir/X11/app-defaults/*
%if_with menu
  %_menudir/%name-X11
%else
  %_desktopdir/%name.desktop
%endif
# backwards compatibility with Master 2x/Compact 30
%{?!_niconsdir:%define _niconsdir %_iconsdir}
%_niconsdir/%name.png
%_miconsdir/%name.png
%_liconsdir/%name.png
# Substitute for buidreq
%_sysconfdir/buildreqs/packages/substitute.d/%name-X11

#
%if_enabled athena
%files X11-athena
%_bindir/%name-athena
%_altdir/%name-athena
# Substitute for buidreq
%_sysconfdir/buildreqs/packages/substitute.d/%name-X11-athena
%endif

#
%if_enabled motif
%files X11-motif
%_bindir/%name-motif
%_altdir/%name-motif
# Substitute for buidreq
%_sysconfdir/buildreqs/packages/substitute.d/%name-X11-motif
%endif

#
%if_enabled gtk
%files X11-gtk
%_bindir/%name-gtk
%_altdir/%name-gtk
# Substitute for buidreq
%_sysconfdir/buildreqs/packages/substitute.d/%name-X11-gtk
%endif

#
%files elisp-manual
%doc lispintro/emacs-lisp-intro.dvi lispref/elisp.dvi
%_infodir/eintr*
%_infodir/elisp*

#
%files gnus
%doc %_emacs_datadir/%emacs_version/etc/GNUS-NEWS
%doc lisp/gnus/ChangeLog*
%dir %_emacs_datadir/%emacs_version/lisp/gnus
%_emacs_datadir/%emacs_version/lisp/gnus/*.elc
%_emacs_datadir/%emacs_version/etc/gnus*
%_emacs_datadir/%emacs_version/etc/images/gnus/
%_emacs_datadir/%emacs_version/etc/images/smilies/
%_infodir/gnus*
%_infodir/message*
%_infodir/emacs-mime*
%_infodir/sieve*
# Substitute for buidreq
%_sysconfdir/buildreqs/packages/substitute.d/%name-gnus

#
%files gnus-el
%_emacs_datadir/%emacs_version/lisp/gnus/*.el.*

#
%files speedbar
%_emacs_datadir/%emacs_version/lisp/dframe.elc
%_emacs_datadir/%emacs_version/lisp/sb-image.elc
%_emacs_datadir/%emacs_version/lisp/speedbar.elc
%_infodir/speedbar*

#
%files erc
%dir %_emacs_datadir/%emacs_version/lisp/erc
%_emacs_datadir/%emacs_version/lisp/erc/*.elc
%_infodir/erc*

%files erc-el
%_emacs_datadir/%emacs_version/lisp/erc/*.el.*


%changelog
* Mon Jul 10 2006 Evgenii Terechkov <evg@altlinux.ru> 22.0.50-alt0.13.20060614.M24.1
- Backport to M24
- Spec cleanups : emacs-base>=0.0.4, rpm-build-compat, s/$RPM_BUILD_ROOT/%%buildroot/
- el-pkgutils.sh relocated, alternatives-0.2.0 => alternatives-0.1.0 conversion (to M24 only)

* Wed Jun 14 2006 Eugene Vlasov <eugvv@altlinux.ru> 22.0.50-alt0.13.20060614
- New snapshot (closes #9635)
- Corrected infos list (removed emacs-extra)

* Sat Apr 29 2006 Eugene Vlasov <eugvv@altlinux.ru> 22.0.50-alt0.12.20060429
- New snapshot
- Removed motif headers hack
- Disabled build motif binary for x86_64
- Increased PURESIZE

* Thu Apr 20 2006 Eugene Vlasov <eugvv@altlinux.ru> 22.0.50-alt0.11.20060420
- New snapshot
- Disabled modification of face-font-selection-order default value
- Droped useless dependency on python (Igor Vlasenko)
- Added optional build with menu, not desktop-file, fixed menu-file (Igor
  Vlasenko)
- For backward compatibility with old distribution define %%_niconsdir if not
  defined (Igor Vlasenko)

* Sun Mar 19 2006 Eugene Vlasov <eugvv@altlinux.ru> 22.0.50-alt0.10.20060319
- New snapshot
- Rediffed jka-compr_bz2_load patch
- Turned back fix for build with motif (for x86_64 build)
- Used %%_niconsdir macro instead of %%_iconsdir for 32x32 icon, renamed icons
- Menu-file replaced by desktop-file
- Fixed info installation

* Thu Feb 23 2006 Eugene Vlasov <eugvv@altlinux.ru> 22.0.50-alt0.9.20060223
- New snapshot
- Rediffed uk patch (ispell-local-dictionary-alist accept now any coding 
  system, supported by Emacs)

* Sun Feb 12 2006 Eugene Vlasov <eugvv@altlinux.ru> 22.0.50-alt0.8.20060211
- New snapshot
- Obsoletes emacs-ses <= 1.0-alt2.031130
- Added (consp) check for save-place-alist elements, loaded from
  ~/.emacs-places (#9053)
- Removed fix for build with motif and Xaw3d

* Fri Feb 03 2006 Eugene Vlasov <eugvv@altlinux.ru> 22.0.50-alt0.7.20060203
- New snapshot
- Added conflict with emacs-gnuserv <= 3.12.7-alt1
- Support for optional build of athena, motif, gtk, nox (Igor Vlasenko)
- Added .dvi files to elisp-manual (Igor Vlasenko)
- Fix for flyspell-buffer merged into upstream
- Rediffed clipboard patch
- Fixed build with motif and Xaw3d
- Added rcirc manual to infos list
- Fixed unpackaged files warning
- Fixed x86_64 build (Igor Vlasenko)
- ERC package included in upstream, build as separate package, obsolete
  old emacs-erc
- el-pkgutils 'fraction' calls replaced with awk code (Igor Vlasenko)

* Sun Dec 11 2005 Eugene Vlasov <eugvv@altlinux.ru> 22.0.50-alt0.6.20051211
- New snapshot
- Now emacs22 obsoletes emacs21, emacs-tramp, emacs-ses, emacs-elisp-manual
- Build speedbar as separate package
- Fix flyspell-buffer for large tex files (thanks to Igor Vlasenko for
  notifying)
- Fix spell checking with aspell in locale coding other than dictionary 
  coding (thanks to Igor Vlasenko for notifying)

* Tue Nov 22 2005 Eugene Vlasov <eugvv@altlinux.ru> 22.0.50-alt0.5.20051122
- New snapshot
- Rediffed more-cyrillic-support patch, require cyrillic-codepages-setup 
  only if purify-flag is nil (not while preparing to dump)
- Disabled builtin compress function for installed .el files (used compress
  function from el-pkgutils)
- Cleanup requires
- Added conflict with old emacs-w3 (with url package inside)
- Used new emacs icons (from Andrew Zhilin)
- Site-start script emacs21-rus-win-keyboard.el renamed to rus-win-keyboard.el

* Mon Oct 24 2005 Eugene Vlasov <eugvv@altlinux.ru> 22.0.50-alt0.4.20051024
- New snapshot
- Added ".bz2" to default value jka-compr-load-suffixes (to enable load
  bzipped libraries and for .el.bz2 source navigation from *Help* window)
- More substitutes for buildreq
- Don't exclude antlr-mode
- Modified build requires for M24 compatibilty (Igor Vlasenko)
- Added README.ALT
- Added check-shadows script for check list of Emacs Lisp files that
  shadow other files (#2622)
- Removed fix for mh-e autoloads
- Fixed macros warnings
- Build with emacs-devel
- Removed dir %%_libdir/%shortname/site-lisp
- Added dir %%_libdir/emacs (emacs-base no more provides this dir)
- Enabled search of aspell dictionaries. Now it preserve elements of
  ispell-dictionary-alist for dictionaries that are not found
- Rediffed patch for decoding headers in gnus
- PGG now part of %name-common (info pages moved too)
- Fixed Summary
- Removed SGID bit of update-game-score binary

* Sat Oct 08 2005 Eugene Vlasov <eugvv@altlinux.ru> 22.0.50-alt0.3.20051008
- New snapshot
- Temporary disable finding aspell dictionaries
- Build gnus
- Build with new speedbar
- Now required emacs-base >= 0.0.4-alt5
- Fixed missing menu icons (thanks to viy@)
- Fixed command in menu file
- Fixed build-time generating autoloads for mh-e
- Added fix for decoding in gnus invalid encoded headers

* Fri Sep 23 2005 Eugene Vlasov <eugvv@altlinux.ru> 22.0.50-alt0.2.20050923
- New snapshot
- Corrected infos list
- Added conflict with emacs-tramp
- Used relative symlink in documentation dir
- Changed X resources default font
- Added substitute emacs22-common with emacs-common for buildreq (#5500)
- Rediffed clipboard patch

* Mon Sep 05 2005 Eugene Vlasov <eugvv@altlinux.ru> 22.0.50-alt0.1.20050902
- CVS snapshot fork
- Rediffed and reworked patches:
  * %shortname-21.2-alt-system.patch
  * %shortname-21.3-alt3-clipboard.patch
  * %shortname-21.2-hide-rcs-deps.patch
  * %shortname-21.2-Meta-Alt-Ctrl-Hyper-super-discard-state.patch
  * %shortname-21.2-pc-select-private-mark.patch
  * %shortname-21.2-face-font-selection-slant-important.patch
  * %shortname-21.3-rh-no_rpath.patch
  * %shortname-21.3-alt4-uk.patch
  * leim-21.1-uk.patch
  * leim-20.6-belarusian.patch
  * %shortname-21.3-ispell-belarusian.patch
  * %shortname-21.3-ispell-russianw.patch
  * %shortname-21.3-alt1-more-cyrillic-support.patch
  * %shortname-21.2-alt12-tutorial-ru.patch
- Removed patches (merged into upstream)
  * %shortname-21.2-HEAD-pc-select.diff
  * %shortname-21.2-ediff-diff-options-check-c.patch
  * %shortname-21.3-use-handler-for-load-of-absolute.patch
  * %shortname-21.3-use-handler-for-load-of-suffixed.patch
  * %shortname-21.2-x86_64.patch
  * %shortname-21.1-lang-env-prereqs.patch
- Build separate packages for athena, motif and gtk binaries
- New alternatives format
- Build ELisp manual
- Updated BuildRequires

* Thu Jul 07 2005 Igor Vlasenko <viy@altlinux.org> 21.3-alt11.vla2
- added conflict with ispell-uk<0.6

* Thu Jun 30 2005 Igor Vlasenko <viy@altlinux.org> 21.3-alt11.vla1
- fixed bug #6853 shift+7 in cyrillic-ukrainian-ms
- fixed bug #835 (added belarussian ispell dict)
- fixed bug #6855 (re-added ukrainian ispell dict)
- fixed bug #6842 (patched emacs21-rus-win-keyboard.el)

* Fri Feb 11 2005 Kachalov Anton <mouse@altlinux.ru> 21.3-alt11
- support for x86_64 (#6089)

* Fri Sep 17 2004 ALT QA Team Robot <qa-robot@altlinux.org> 21.3-alt10.1.1
- Rebuilt with libtiff.so.4.

* Thu Jun 10 2004 Stanislav Ievlev <inger@altlinux.org> 21.3-alt10.1
- NMU: fix alternatives usage (rename candidates in remove_alternative macros)

* Mon May 03 2004 Ott Alex <ott@altlinux.ru> 21.3-alt10
- Fix bug #2676
- Fix bug #883
- Fix bug #1159
- Fix bug #1502
- Fix bug #2217
- Fix bug #3885
- Fix bug #2566

* Sat Mar 27 2004 Ott Alex <ott@altlinux.ru> 21.3-alt9
- Fixing entry in menu

* Sat Jan 31 2004 Ott Alex <ott@altlinux.ru> 21.3-alt8
- Fixing entry in menu
- Install new smtpmail with support of SMTP Auth

* Mon Jan 12 2004 Ott Alex <ott@altlinux.ru> 21.3-alt7
- Fixing spec to properly rebuild

* Sat Jan 10 2004 Ott Alex <ott@altlinux.ru> 21.3-alt6
- Name changed to emacs21 
- Remove compression of .elc files
- Remove dependence on speedbar
- Remove gnus and dependence on it
- Added missed buildreq on sendmail
- Move emacs-pkgtools to emacs-base

* Sun Nov 30 2003 Ott Alex <ott@altlinux.ru> 21.3-alt5
- Reorganize package 
- move php-mode.el to emacs-prog-modes package

* Wed Apr 09 2003 Stanislav Ievlev <inger@altlinux.ru> 21.3-alt4.1
- new alternatives format

* Fri Apr  4 2003 Ivan Zakharyaschev <imz@altlinux.ru> 21.3-alt4
- lisp: autoload `cyrillic-encode-koi8-r-char' (was lost in patch20 "uk")

* Tue Apr  3 2003 Ivan Zakharyaschev <imz@altlinux.ru> 21.3-alt3
- mouse & PRIMARY X selection: restore the behaviour introduced
  by 21.2-alt11-clipboard.patch (lost in 21.3-alt1; patch3)

* Tue Apr  1 2003 Ivan Zakharyaschev <imz@altlinux.ru> 21.3-alt2
- built-in `load': always use the load-handler if it is present 
  (e.g. for compressed .elc's; fixes No. 0002355; patches 11 and 12);
- lisp: 
  + `vc-cvs-registered' function: split into parts for autoloading
    without any loops (No. 0002334 at bugs.altlinux.ru; patch13);
  + php-mode updated to 1.04;
- docs: include AUTHORS, symlink etc/;
- spec:
  + make updates (regenerate autoloads, cus-deps etc.) at the %%build stage;
  + supply install-info path to %%makeinstall (to get less error msgs);

* Tue Mar 25 2003 Ivan Zakharyaschev <imz@altlinux.ru> 21.3-alt1
- new upstream version;
- files: include /usr/bin/{ebrowse,grep-changelog} in emacs-common pkg
  (No. 0002354 at bugs.altlinux.ru)
- Cyrillic support improvements (patch33):
  + language-env detection improved for be*, ru*, uk* & *iso8859-5 locales;
  + info manual reflects the support for various Cyrillic-based language-envs
    (based on the "uk" patch);
  + Ukrainian word for "Ukrainian" fixed in HELLO (No. 0002213);
- spec & patches (not visible to a user): 
  + simplify the menu file (s:%%version:X11:);
  + include /usr/bin/* in emacs-common pkg (and exclude emacs-{nox,X11});
  + patch3 (clipboard): default xselection coding-system value is already correct upstream;
  + patch9 (regex-encoded): upstream (not ours);
  + patch20 (uk): redone, some parts extended and moved to patch33 (more-cyrillic);
  + patch31 (dumbterm-for-compile): finally upstream;
  + patch32 (cp866fix): upstream;

* Fri Mar 14 2003 Stanislav Ievlev <inger@altlinux.ru> 21.2-alt16
- PreReq fixes

* Wed Mar 12 2003 Stanislav Ievlev <inger@altlinux.ru> 21.2-alt15
- moved to new alternatives scheme
- warning to maintainer: added missing PreReq on update-alternatives


* Mon Feb 10 2003 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt14
- changes to better support various Cyrillic X fonts 
  (news in patch33):
  + faces.el: face-font-registry-alternatives: list the wide-spread 
    alternatives for Cyrillic iso8859-5 (microsoft-cp1251, koi8-u, koi8);
  + fontset.el: leave "ISO8859-5" as the REGISTRY-ENCODING for Cyrillic;
  + fontset.el: change the FAMILY for Cyrillic from "*" (any) to nil 
    (the same a sthe default), because Cyrillic is like Latin: the family
    plays just hte same role;
  + describe koi8-c X font encoding (for now, just as an alias for koi8-u);
  (patch10):
  + make :slant the most important property when selecting a font for a face
    (imho, the absence of slanted fonts makes the visual appearance dull);
  (source31):
  + remove all font-related settings from /etc/X11/app-defaults/Emacs (which
    used to be brute), add only "Emacs.default.attributeFamily: fixed";
  + now, there is no need to specify rather brute values in localized
    /etc/X11/Xresources.* in order to get the right encoded Cyrillic font --
    we get it without any special X resources, if the Cyrillic font is 
    available (modify app-defaults accordingly!);
    (a part of the fix for No. 0000825, 0001478, 0001681; complete 0000997);
- open bzipped2 .el files (as well as gzipped which was supported before)
  when following links from the Help buffer (e.g., C-h v) (patch1;
  fixes No. 0001927 at http://bugs.altlinux.ru).

* Mon Feb 10 2003 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt13
- fix regex processing for some specially encoded texts (patch9, useful
  for Gnus, sent by Alex Ott <ottalex@narod.ru>);
- add BuildRequires(install): bzip2-utils (to fix No. 0001911).

* Sun Dec  8 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt12
- files: 
  + include non-el/elc files from lisp/ (mainly xpm; fixes No. 0001387);
  + exclude gnus/ from emacs-common (it was included in a previous revision);
  + compress .el-files in *-el pkgs;
- corrected TUTORIAL.ru (Alex Ott <ottalex@narod.ru>);
- spec-file: thoroughly check that all info-files are included
  (fixes No. 0001386);

* Sun Nov 17 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt11
- make possible primary X selection setting & pasting with mouse
  (in addition to clipboard manipulation with keys; fixes No. 1356);
- pc-selection-mode: turn-offable; no conflict with traditional 
  selection manipulation keys (like C-space; fixes No. 1357 at 
  bugs.altlinux.ru);
- lisp/ediff-diff.el: refine the check for valid ediff-diff-options;

* Sat Nov  9 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt10
- make finer distinction between koi8-r & koi8-u font encodings
  (fixes No. 997 at bugs.altlinux.ru).

* Fri Nov  8 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt9
- make keys like C-h, M-x work even when the (say) Russian XKB 
  group is active (patch5, discard almost the whole state if
  a certain modifier is detected; fixes No. 852 at bugs.altlinux.ru).
  (Please REPORT any related misbehaviors!)

* Thu Nov  7 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt8
- use --host=%%_target_platform for ./configure (fixes No. 1535
  at bugs.altlinux.ru).

* Tue Nov  5 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt7
- lisp: leave gnus/format-spec.el* in the main pkg (do not put in gnus):
  kind of essential library (required by tramp);
- scripts:
  + do not install {dir,info}.info; do install idlwave.info;
  + do not install speedbar.info (belongs to the speedbar package);
    WARNING: unless you reinstall emacs-speedbar, its info entry won't
    appear in the catalog;
- gnus subpkg:
  + Provides: gnus = %%name:%%version-%%release; Conflicts: gnus !=...; 
    I suppose other Gnus pkgs should do the same;
  + move {emacs-mime,message}.info to this subpkg.

* Sun Nov  3 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt6
- install more info;
- separate gnus{,-el} (alternatives would be complex in this case due to
  info and etc/, so other gnus should merely conflict with these ones).

* Fri Jul 19 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt5
- follow the convention about using POSIX locks (with fcntl(2)) for 
  mailbox access (in movemail; nnmbox users take care on your own!);
- drop privileges of movemail utility (no dot-locking in /var/mail/); 
- link with tinfo, not ncurses (everything is there in the latest release);
- remove termcap from build deps;
- lisp: drop speedbar.el{,c}, speedbar.info -- you will find it 
        in a separate pkg (Alex Ott <ottalex@narod.ru>);
- etc: add TUTORIAL.ru (Alex Ott);
- rcs-checkin: hide the dependencies on rcs (mhz).

* Sun Apr 14 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt4
- lisp: 
  + add support for X Compound Text with Extended Segments
    in koi8-u and microsoft-cp1251 (koi8-r support already present
    in the offcial GNU release; this is the complete fix for \#786
    at bugs.altlinux.ru);
  + add cp1251 item to the list of choices for ispell coding;
- package:
  + correct preun-scripts (alternative management) (Sorry, you will 
    have to uninstall 21.2-alt3 manually with --noscripts);

* Fri Apr 12 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt3
- rename: /usr/bin/emacs-21.2 to /usr/bin/emacs-X11
  (to overcome the alternatives nightmare);

* Fri Apr 12 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt2
- package: 
  + add Confilcts on older etcskel & app-defaults (the
    old ones use values considered bad for 21.2);
  + Groups of *-el subpkgs changed to Development/Other;
- lisp: add support for X fonts in koi8 and *1251;


* Mon Apr  8 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt1
- new mainstream release (21.2):
  + now supports ICCCM Extended Segments in X selctions (fixes \#786 at
    bugs.altlinux.ru) -- don't forget to sync etcskel's to use c-text 
    for selections;
- lisp: 
  + prefer clipboard over primary selection (the reasononig given in
    \#795 at bugs.altlinux.ru);
  + the default value for selection-coding-system: 
    compound-text -> compound-text-with-extensions (this is the second part of
    the fix for \#786 at bugs.altlinux.ru)
  + Encoded-kb mode indicator turned off in mainstream release, so 
    we are not applying our previous patch any more;
-config:
  + use "Emacs" class as a specifier for X resourcers (was: "emacs" name)
    (fixes \#764 at bugs.altlinux.ru) -- don't forget to sync /etc/Xresources;
- spec-file:
  + dumbterm-for-compile patch regenerated;
  + alternatives: 
    * weights for alternatives shifted by %%{alternativeMajor}00;
    * removal in %%preun to avoid collisions;

* Thu Mar  1 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt13
- fix broken deps between emacsen-startscripts and and emacs-{X11,nox}:
  the pkgs with Emacs executables now provide `emacsen'.

* Thu Feb 28 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt12
- make co-existence with other Emacsen (XEmacs) easier:
  + move the site start scripts to a separate pkg (emacsen-startscripts; 
    they should be shared between GNU and X- Emacsen); buildreq rules for
    the directory with the scripts also moved to that pkg;
  + emacs-{nox,X11} provide emacsen (should be also provided 
    by XEmacs binaries);
  + emacs-{nox,X11} require emacsen-startscripts (should be also required 
    by XEmacs binaries);

* Sat Feb 25 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt11
- get rid of the inconsistency in versions and documentation data between 
  emacs-X11 and emacs-nox variants (fixes \#601, \#612 in bugs.altlinux.ru)
  (%%build stage modified to achieve this);
- add more strict %%release dependencies;
- add support for loading bzipped2 .el/.elc; compress several large files;
- lisp:
    + encoded-kbd: make indicator string shorter;
    + cyrillic-codepages-setup: override `valid-codes' property with more 
      correct values (this fixes hanging on C-x; Note: if you do 
      codepage-setup manually, then it is not fixed for you);
- config:
    + macros: rename noXlaunch -> TTYlaunch;
    + mouse: attempt to use mouse in Linux console and Xterm;
    + initial-features: turn on column-number and eldoc (for el only) modes;
- spec-file:
  + %%install: handle menu simpler;
  + make a patch instead of the separate HELLO.re (append it to Patch20);
  + %%install: generate filelists using el-pkgutils (it should be used also
    in other pkgs with Emacs Lisp code);

* Sun Feb  9 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt10
- lisp: 
  + new version of php-mode (1.0.2); compile it;
    on site-start, initialize autoload of it (php-mode);
  + add more seamless support for Cyrillic language environments based
    on CP1251, CP866 and CP1125;
  + fix CP866 table;
- config:
  + special bindings for selection management discarded -- the defaults 
    work fine (even for X); support for analogous KeyPad bindings added 
    (suggested by vyt@vzljot.ru);
  + X resources: set our values for colour classes; use "Helv" font 
    family for the menu;
  + do not fail completely if the Flyspell feature fails;
  + mouse wheel support turned on;
  + defined GNU-/XEmacs and Xlaunch macros (to be used in personal configs, etcskels);
  + split the config into small parts;
- menu: explicitly specify the X11-variant of emacs;
- spec-file:
  + Head: thrown away unused and recompiled sources; 
    not used terminfo patch left for a while: do we need it??;
  + build: do not copy any byte-compiled .elc files into the build 
    tree -- all of them now get recompiled from the patched sources 
    (particularly quail/cyrillic.elc from leim);
  + install: move menu entry to a separate file;
  + scriplets: use %%*_menus macros;
  + install: cut down "$RPM_BUILD_ROOT" usage;
  + detect errors during Emacs Lisp compilation;

* Thu Jan 24 2002 Dmitry V. Levin <ldv@alt-linux.org> 21.1-alt9
- Added emacs filter for buildreq.

* Thu Dec 27 2001 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt8
- configuration:
  + really turn on pc-selection-mode;
  + move frame properties from site-start.el to X resources;
- lisp: really apply our patches by recompiling the patched sources;
- .el/.elc fractions improved:
  + do not loose any not-compiled .el-files in the emacs-common pkg;
  + split emacs-el into emacs-el and emacs-leim-el subpkgs;
- "TERM in Compile" patch extended (idea by rms@gnu.org);

* Wed Dec 26 2001 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt7
- inherit ispell-dictionary value from the DICTIONARY environment variable
- fix the "TERM in Compile" patch -- now it works

* Wed Dec 26 2001 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt6
- configuration from MdkRE's etcskel-* merged into the global Emacs' config
- set TERM=dumb for compile (for nice output of colorgcc and other programs)
- set ownership on various directories for clean pkg removal
- FAQ excluded from the documentation

* Tue Nov 20 2001 AEN <aen@logic.ru> 21.1-alt5
- update-alternatives fixed (bug 168,169)
- new php-mode.el (bug 170)

* Thu Nov 15 2001 AEN <aen@logic.ru> 21.1-alt4
- fix typo in previous changelog record
- some MDK improvements added

* Tue Nov 13 2001 AEN <aen@logic.ru> 21.1-alt3
- ukrainiazation from Serhii Hlodin

* Thu Nov 1 2001 AEN <aen@logic.ru> 21.1-alt2
- leim cyrillic patches restored

* Mon Oct 22 2001 AEN <aen@logic.ru> 21.1-alt1
- new version

* Fri May 18 2001 Stanislav Ievlev <inger@altlinux.ru> 20.7-ipl9mdk
- Repackaged.
- Moved common %name stuff to %name-common subpackage.
- Used update-alternatives for %name-nox and %name-X11 subpackages.
- Fixed terminfo linkage.

* Sat Feb 17 2001 AEN <aen@logic.ru>
- groups names fixed

* Sat Jan 20 2001 AEN <aen@logic.ru>
- belarusian script in HELLO fixed (Alexander Bokovoy)

* Tue Dec 26 2000 AEN <aen@logic.ru>
- spec cleanup

* Thu Dec 07 2000 AEN <aen@logic.ru>
- 20.7
- rebuild for 7.2RE

* Sat Mar 11 2000 Oleg Tihonov <tihonov@ffke-campus.mipt.ru>
- load belarusian code at startup

* Thu Jan 13 2000 Oleg Tihonov <tihonov@ffke-campus.mipt.ru>
- added belarusian language support

* Tue Nov 9 1999 AEN <aen@logic.ru>
- bzipped man-pages
- custom.gz removed
- build for 6.1RE

* Fri Sep 17 1999 Oleg Tihonov <tihonov@ffke-campus.mipt.ru>
- move to 20.4
- add Ukrainian patches

* Wed May 26 1999 Bernhard Rosenkr䮺er <bero@mandrakesoft.com>
- move the %_bindir/%name script to the %name package

* Wed May 26 1999 Bernhard Rosenkr䮺er <bero@mandrakesoft.com>
- s/arch-redhat-linux/arch-mandrake-linux
- replace %name with a shell script that runs either %name-nox or
  %name-20.3
- s/%name/%name-20.3/ in %name.wmconfig (wmconfig is always X)

* Fri Apr 23 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Mandrake adpatations.
- Bzip2 info/man pages.
- Path to handle bzip2 on info files.

* Wed Mar 31 1999 Preston Brown <pbrown@redhat.com>
- updated mh-utils %name lisp file to match our nmh path locations

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com>
- auto rebuild in the new build environment (release 9)

* Fri Feb 26 1999 Cristian Gafton <gafton@redhat.com>
- linker scripts hack to make it build on the alpha

* Fri Jan  1 1999 Jeff Johnson <jbj@redhat.com>
- add leim package (thanks to Pavel.Janik@inet.cz).

* Fri Dec 18 1998 Cristian Gafton <gafton@redhat.com>
- build against glibc 2.1

* Wed Sep 30 1998 Cristian Gafton <gafton@redhat.com>
- backed up changes to uncompress.el (it seems that the one from 20.2 works
  much better)

* Mon Sep 28 1998 Jeff Johnson <jbj@redhat.com>
- eliminate /tmp race in rcs2log

* Wed Sep 09 1998 Cristian Gafton <gafton@redhat.com>
- upgrade to 20.3

* Tue Jun  9 1998 Jeff Johnson <jbj@redhat.com>
- add --with-pop to X11 compile.
- include contents of %_datadir/.../etc with main package.

* Mon Jun 01 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr

* Mon Jun 01 1998 David S. Miller <davem@dm.cobaltmicro.com>
- fix signals when linked with glibc on non-Intel architectures
  NOTE: This patch is not needed with %name >20.2

* Thu May 07 1998 Prospector System <bugs@redhat.com>

- translations modified for de, fr, tr

* Thu May 07 1998 Cristian Gafton <gafton@redhat.com>
- added %_libdir/%name/20.2/*-mandrake-linux directory in the filelist

* Thu Apr 09 1998 Cristian Gafton <gafton@redhat.com>
- alpha started to like %name-nox again :-)

* Thu Nov  6 1997 Michael Fulbright <msf@redhat.com>
- alpha just doesnt like %name-nox, taking it out for now

* Mon Nov  3 1997 Michael Fulbright <msf@redhat.com>
- added multibyte support back into %name 20.2
- added wmconfig for X11 %name
- fixed some errant buildroot references

* Thu Oct 23 1997 Michael Fulbright <msf@redhat.com>
- joy a new version of %name! Of note - no lockdir any more.
- use post/preun sections to handle numerous GNU info files

* Mon Oct 06 1997 Erik Troan <ewt@redhat.com>
- stopped stripping it as it seems to break things

* Sun Sep 14 1997 Erik Troan <ewt@redhat.com>
- turned off ecoff support on the Alpha (which doesn't build anymore)

* Mon Jun 16 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Fri Feb 07 1997 Michael K. Johnson <johnsonm@redhat.com>
- Moved ctags to gctags to fit in the more powerful for C (but less
  general) exuberant ctags as the binary %_bindir/ctags and the
  man page /usr/man/man1/ctags.1

# Local Variables:
# compile-command: "rpm -ba --sign --target=i686 emacs22.spec"
# End:
